
#include <QtGui>

#include "filelist.h"

FileList::FileList(QWidget *parent)
    : QTreeView(parent)
{
    setAcceptDrops(true);
}

void FileList::dragEnterEvent(QDragEnterEvent *event)
{
    event->acceptProposedAction();
    //emit changed(event->mimeData());
}

void FileList::dragMoveEvent(QDragMoveEvent *event)
{
    event->acceptProposedAction();
}

void FileList::dropEvent(QDropEvent *event)
{
    const QMimeData *mimeData = event->mimeData();
    QList<QByteArray> formats = QImageReader::supportedImageFormats();
    QString file, ext;
    QString niceName;
    int pos, rc;
    if (mimeData->hasUrls()) {
        QList<QUrl> urlList = mimeData->urls();
        for (int i = 0; i < urlList.size() && i < 32; ++i) {
            QStandardItemModel *mod = (QStandardItemModel*)model();
            file = urlList.at(i).path();

            ext = file.toLower();
            pos = ext.lastIndexOf(".");
            if (pos != -1)
                ext.remove(0, pos + 1);
            if(formats.indexOf(ext.toAscii()) == -1){
                continue;
            }

            //file.remove(0,1);
            rc = mod->invisibleRootItem ()->rowCount();
            mod->insertRow(rc);
            niceName = file;
            niceName.replace("\\", "/");
            pos = niceName.lastIndexOf("/");
            if (pos != -1)
                niceName.remove(0, pos + 1);

            mod->setData( mod->index(rc, 0) , niceName );
            mod->setData( mod->index(rc, 1) , "" );
            mod->setData( mod->index(rc, 2) , file );
            mod->itemFromIndex(mod->index(rc, 0))->setFlags(Qt::ItemIsEnabled|Qt::ItemIsSelectable);
            mod->itemFromIndex(mod->index(rc, 2))->setFlags(Qt::ItemIsEnabled|Qt::ItemIsSelectable);

        }

    }
    event->acceptProposedAction();
}

void FileList::dragLeaveEvent(QDragLeaveEvent *event)
{
    event->accept();
}
